/*
 * Startup note:
 *
 *  - Copy the app.js and index.js to desired folder on your BB(B).
 *  - Edit the port variable if some other app is already listening on port 8888.
 *  - Comment/Uncommnet pin definitions depending on used mikroBUS socket.
 *  - Navigate to folder with projec files in Terminal and type: node app.js
 * 
 *  - Using ifconfig in terminal you can find the IP address of the device (IP.IP.IP.IP).
 *  - Use the IP address with configured port number to acccess Remote Relay Control application
 *  - Type in browser address bar: IP.IP.IP.IP:PORT
 */

var fs   = require("fs");
var http = require("http");
var url  = require("url");
var bs   = require("bonescript");
var port = 8888; // Define port for server access

var state1, state2;

/* mikroBUS 1 */
var rl1 = 'P9_14';
var rl2 = 'P8_12';

/* mikroBUS 2 */
// var rl1 = 'P8_19';
// var rl2 = 'P8_16';

state1 = bs.LOW;
state2 = bs.LOW;
bs.pinMode(rl1, bs.OUTPUT);
bs.pinMode(rl2, bs.OUTPUT);
bs.digitalWrite(rl1, state1);
bs.digitalWrite(rl2, state2);

function serveIndex(response){
  response.writeHead(200, {"Content-Type": "text/html"});  
  fs.readFile('index.html', 'utf8', function(err, data){
    if(!err){      
      response.write(data);
    }
    response.end();          
  });  
}

http.createServer(function(request, response) {
  var cmd = url.parse(request.url).pathname;
	switch(cmd){
	  case '/r1':
        if (state1 == bs.LOW){
          state1 = bs.HIGH;
          console.log("Relay1 ON");
        }
        else{
          state1 = bs.LOW;
          console.log("Relay1 OFF");
        }
        bs.digitalWrite(rl1, state1);                // After pin update
        response.writeHeader(302, {Location: "/"});  // Redirect user to index page
        response.end();
	  break;
	  case '/r2':
	    if (state2 == bs.LOW){
          state2 = bs.HIGH;
          console.log("Relay2 ON");
	    }
        else{
          state2 = bs.LOW;
          console.log("Relay2 OFF");
        }
        bs.digitalWrite(rl2, state2);                // After pin update
        response.writeHeader(302, {Location: "/"});  // Redirect user to index page
        response.end();
	  break;
	  case '/var':
        response.writeHead(200, {"Content-Type": "text/javascript"});          // For script request 
	    response.write("var relayState = [" + state1 + "," + state2 + "];");   // Define variable which will be used in HTML java script 
		response.end();  
	  break;
      default:
        serveIndex(response);  // For all other(not defined) requests serve the index page
      break;
	}	
}).listen(port);
console.log("Remote Relay Control app is active on port: " + port);
